# FIXME: We get compilation failures in device code when we enable debuginfo:
# Invalid bitcast
# i64 addrspace(2)* bitcast (%struct.tile addrspace(1)* @_ZL6lwSize to i64 addrspace(2)*)
# /usr/libexec/hcc/bin/llvm-link: error: linked module is broken!
%global debug_package %{nil}

%global commit a09c6402da5d3044ea6d7023a8cb122a47cc6d83
%global shortcommit %(c=%{commit}; echo ${c:0:7})
%global git_branch rocm1.6

Name:		hcfft
Version:	0.1
Release:	0.4.20171215git%{shortcommit}%{?dist}
Summary:	hcc based fft library

License:	MIT
URL:		https://github.com/ROCmSoftwarePlatform/hcFFT
Source0:	https://github.com/ROCmSoftwarePlatform/hcFFT/archive/%{commit}/%{name}-%{git_branch}-%{shortcommit}.tar.gz
Patch0:		0001-Fix-reading-HIP_PATH-environment-variable.patch
Patch1:		0001-Fix-compiler-detection.patch
# The rocminfo platform detection fails on the koji builders since there is
# no hsa device, so we need to specify the amdgput targets to build for.
# We also need to do this in order to support multiple architectures.
Patch2:		0001-Explicitly-specify-amdgpu-targets.patch


BuildRequires:	cmake
BuildRequires:	hip

%{!?enable_llvmtoolset7: %define enable_llvmtoolset7 %{nil}}
%{!?enable_devtoolset7: %define enable_devtoolset7 %{nil}}

%if 0%{?rhel} == 7
# FIXME: Manually define enable_llvmtoolset7 until llvm-toolset-7-5.0.1 is
# available
%enable_llvmtoolset7 %global ___build_pre %{___build_pre}; source scl_source enable llvm-toolset-7 || :

BuildRequires: llvm-toolset-7-cmake
BuildRequires: llvm-toolset-7-runtime
BuildRequires: devtoolset-7-build
BuildRequires: devtoolset-7-gcc-c++

%enable_llvmtoolset7
%enable_devtoolset7
%global __cmake cmake
%endif

%description
hcc based fft library

%prep
%autosetup -n hcFFT-%{commit} -p1


%build
export HCC_HOME=/usr
export HIP_PATH=/usr

./build.sh


%install
mkdir -p %{buildroot}%{_libdir}
mkdir -p %{buildroot}%{_includedir}/hipfft

install -m 0755 build/lib/src/libhcfft.so %{buildroot}/%{_libdir}
install -m 0755 build/lib/src/libhipfft_hcc.so %{buildroot}/%{_libdir}

cp -R lib/include/* %{buildroot}%{_includedir}/hipfft

%files
%doc README.md
%{_libdir}/libhcfft.so
%{_libdir}/libhipfft_hcc.so
%{_includedir}/hipfft/*



%changelog
* Mon Mar 12 2018 Tom Stellard <tstellar@redhat.com> - 0.1-0.4.20171215gita09c640
- Don't undef _missing_build_ids_terminate_build.  hcc supports build-ids now.

* Mon Mar 12 2018 Tom Stellard <tstellar@redhat.com> - 0.1-0.3.20171215gita09c640
- Add epel support

* Mon Feb 26 2018 Tom Stellard <tstellar@redhat.com> - 0.1-0.2.20171215gita09c640
- Explicitly specify amdpgpu targets

* Sat Dec 16 2017 Tom Stellard <tstellar@redhat.com> - 0.1-0.1.20171215gita09c640
- Version 0.1


